Transparency shader doesn't cast shadows with curve segments
Closed, ResolvedPublic

Description

System Information
Windows 10 64b, intel i5 6400

Blender Version

It's broken in 2.78a b76dbf5, 64f5afd,

It works on the stable release and on autobuilds from earlier in the year

Short description of error

bad

good

Curve segment hairs don't cast any shadow from transparent shaders. It only happens on curve segments, not line segments or triangle.

Open the file in both Blender versions, render and check the results. Alternatively, you can switch to line segment or triangle hairs.

To replicate from scratch, use a transparent shader with semitransparency, or even completely black, i also recommend restricting the transparency shader to the shadows using lightpath node so the effect is more visible when combined with a diffuse shader, like in the example.

Details

Type
Bug
Joey Ferwerda (TheOnlyJoey) triaged this task as Confirmed priority.Jan 27 2017, 1:45 AM

Confirmed, works 2.78a, does not on current buildbot.

Sergey Sharybin (sergey) lowered the priority of this task from Confirmed to Incomplete.Mar 20 2017, 3:24 PM

I don't see any difference of rendered result when comparing 2.77a, 2.78a, 2.78c and latest master.

Please verify the issue still happens with latest buildbot, and if so attach system-info.txt generated by Help -> Save System Info.

It still happens on latest buildbot, on my system at least. Everything was rendered on CPU

In case it helps, I also noticed artifacts that are more visible when reducing the steps resolution of the hair. It's not completely transparent.
Here I reduced the steps count from 3 to 1. The artifact also looks different depending if Hair BVH is used or not


Sergey Sharybin (sergey) raised the priority of this task from Incomplete to Confirmed.Mar 20 2017, 4:45 PM
Sergey Sharybin (sergey) claimed this task.

Managed to reproduce the issue on WIndows. Annoyingly,m only happens in release build. Could be a fault of optimizer.

Mind double-checking my theory that msvc2015 builds are free from this bug? (you can get those from builder.blender.org)

the bug is indeed gone in msvc2015 build

Sergey Sharybin (sergey) closed this task as Resolved.Mar 22 2017, 11:41 AM

Committed a work around for now. We are planning to abandon MSVC2013, so not really motivated spending days nailing down the issue.

Thanks for the report, closing now.